/*
 *	demo.c
 */
#include "app.h"

/****************************************************************************
 *	demo
 ****************************************************************************/

static int sub_title_select;	/* 0:޳/1:DIATOMIC */
static char* sub_title[2][8] = {
	{ "", "", "", "", "", "", "", "" },
	{ "D", "I", "A" , "T", "O" , "M", "I", "C" },
};
static char* menu[] = {
	"TRIAL",
	"BATTLE",
	"EXIT",
};
#define N_MENU	(sizeof menu / sizeof *menu)
#define MENU_X	5
#define MENU_Y	6
static char* version = "VERSION 0.02";

#define SUBTITLE_DELAY	-SEC(0.5)
#define TITLE_TIMEOUT	 SEC(10)

/* ^CgEX^[g҂(b) */
int
demo()
{
	static int select; /*j[I͑ȎIlƂ*/
	int result, i, count, x, y;

	BSET(state, STATE_DEMO);

	bg_clear_all(0);
	bg_clear_all(1);
	sprite_clear_all();

	/* ^CgȂǕ\B
	 * Tu^Cg̓fĂ΂閈ɐ؂ւ܂B
	 */
	bg_block(0, 2, 3, CHR_TITLE, 12, 2);
	for(i = 0; i < N_MENU; i++) {
		bg_print(0, MENU_X, MENU_Y + i, menu[i]);
	}
	bg_print(0, 2, 10, version);

	/* CvCB */
	t_wipe(1);
	while(BTST(state, STATE_WIPE)) period();

	result = -1;		/* l^CAEgƂĂ */
	for(count = SUBTITLE_DELAY; count < TITLE_TIMEOUT; count++) {
		/* A{^邩A^CAEgŔ܂B */
		if(pad & TRG_A) {
			result = select;
			break;
		}
		if(count == SEC(5)) break;

		/* j[IB */
		if(select > 0          && pad & TRG_UP) {
			select--;
			sound_start(1, CLICK3);
		}
		if(select < N_MENU - 1 && pad & TRG_DN) {
			select++;
			sound_start(1, CLICK3);
		}

		/* j[̑IʒuɁA_ŃJ[\\B */
		for(i = 0; i < N_MENU; i++) {
			if((timer & 7) < 5 && select == i) {
				bg_print(0, MENU_X - 1, MENU_Y + i, ">");
			} else {
				bg_print(0, MENU_X - 1, MENU_Y + i, " ");
			}
		}

		/* Tu^CgoB */
		if(0 <= count && count < 8) {
			x = 4 + count;
			y = 2;
			bg_print(0, x, y, sub_title[sub_title_select][count]);
			x = x * 8 - 4;
			y = y * 8 - 4;
			hamon_new(sub_title_select + 1, x, y);
		}

		period();
	}

	/* CvAEgB */
	t_wipe(0);
	while(BTST(state, STATE_WIPE)) period();

	/* ̃Tu^Cg؂ւ܂B */
	sub_title_select = !sub_title_select;

	BCLR(state, STATE_DEMO);

	/* -1:^CAEg/0:gCA/1:og/2:IB */
	return result;
}
